## pgbouncer

pgbouncer — a Postgres Pro connection pooler

## Synopsis

On Linux systems:

`pgbouncer` [ -d ] [ -R ] [ -v ] [ -u `user` ] pgbouncer.ini

`pgbouncer` -V | -h

On Windows systems:

`pgbouncer` [ -v ] [ -u `user` ] pgbouncer.ini

`pgbouncer` -V | -h

To use pgbouncer as a Windows service:

`pgbouncer.exe` --regservice pgbouncer.ini

`pgbouncer.exe` --unregservice pgbouncer.ini

## Description

pgbouncer is a Postgres Pro connection pooler. Any target application can be connected to pgbouncer as if it were a Postgres Pro server, and pgbouncer will create a connection to the actual server, or it will reuse one of its existing connections.

The aim of pgbouncer is to lower the performance impact of opening new connections to Postgres Pro.

In order not to compromise transaction semantics for connection pooling, pgbouncer supports several types of pooling when rotating connections:

Session pooling

  Most polite method. When a client connects, a server connection will be assigned to it for the whole duration the client stays connected. When the client disconnects, the server connection will be put back into the pool. This is the default method.

Transaction pooling

  A server connection is assigned to a client only during a transaction. When pgbouncer notices that transaction is over, the server connection will be put back into the pool.

Statement pooling

  Most aggressive method. The server connection will be put back into the pool immediately after a query completes. Multi-statement transactions are disallowed in this mode as they would break.

The administration interface of pgbouncer consists of some new `SHOW` commands available when connected to a special “virtual” database `pgbouncer`.

### Quick Start

Basic setup and usage is as follows.

1. Create a `pgbouncer.ini` file. Details in the `pgbouncer(5)` man page. Simple example:

       [databases]
       template1 = host=127.0.0.1 port=5432 dbname=template1

       [pgbouncer]
       listen_port = 6543
       listen_addr = 127.0.0.1
       auth_type = md5
       auth_file = userlist.txt
       logfile = pgbouncer.log
       pidfile = pgbouncer.pid
       admin_users = someuser

2. Create a `userlist.txt` file that contains the users allowed in:

       "someuser" "same_password_as_in_server"

3. Launch pgbouncer:

       $ pgbouncer -d pgbouncer.ini

   ### Note

   The above command does not work on Windows systems. Instead, pgbouncer must be launched as a service that first needs to be registered, as follows:

       pgbouncer --regservice

4. Have your application (or the `psql` client) connect to pgbouncer instead of directly to the Postgres Pro server:

       $ psql -p 6543 -U someuser template1

5. Manage pgbouncer by connecting to the special administration database pgbouncer and issuing `SHOW HELP;` to begin:

       $ psql -p 6543 -U someuser pgbouncer
       pgbouncer=# SHOW HELP;
       NOTICE:  Console usage
       DETAIL:
         SHOW [HELP|CONFIG|DATABASES|FDS|POOLS|CLIENTS|SERVERS|SOCKETS|LISTS|VERSION|...]
         SET key = arg
         RELOAD
         PAUSE
         SUSPEND
         RESUME
         SHUTDOWN
         [...]

6. If you made changes to the `pgbouncer.ini` file, you can reload it with:

       pgbouncer=# RELOAD;

## Options

`-d`

  Run in the background. Without it, the process will run in the foreground.

  ### Note

  Does not work on Windows, pgbouncer needs to run as service there.

`-R`

  Do an online restart. That means connecting to the running process, loading the open sockets from it, and then using them. If there is no active process, boot normally.

  ### Note

  Works only if OS supports Unix sockets and the `unix_socket_dir` is not disabled in configuration. Does not work on Windows. Does not work with TLS connections, they are dropped.

`-u `user``

  Switch to the given user on startup.

`-v`

  Increase verbosity. Can be used multiple times.

`-q`

  Be quiet: do not log to `stdout`. This does not affect logging verbosity, only that `stdout` is not to be used. For use in `init.d` scripts.

`-V`

  Show version.

`-h`

  Show short help.

`--regservice`

  Win32: Register to run as Windows service. The `service_name` configuration parameter value is used as the name to register under.

`--unregservice`

  Win32: Unregister Windows service.

## Admin Console

The console is available by connecting as normal to the database pgbouncer:

    $ psql -p 6543 pgbouncer

Only users listed in the configuration parameters `admin_users` or `stats_users` are allowed to log in to the console. (Except when `auth_mode=any`, then any user is allowed in as a `stats_user`.)

Additionally, the user name `pgbouncer` is allowed to log in without password, if the login comes via the Unix socket and the client has same Unix user uid as the running process.

### Show Commands

The `SHOW` commands output information. Each command is described below.

#### SHOW STATS

Shows statistics. In this and related commands, the total figures are since process start, the averages are updated every `stats_period`.

`database`

  Statistics are presented per database.

`total_xact_count`

  Total number of SQL transactions pooled by pgbouncer.

`total_query_count`

  Total number of SQL queries pooled by pgbouncer.

`total_received`

  Total volume in bytes of network traffic received by pgbouncer.

`total_sent`

  Total volume in bytes of network traffic sent by pgbouncer.

`total_xact_time`

  Total number of microseconds spent by pgbouncer when connected to Postgres Pro in a transaction, either idle in transaction or executing queries.

`total_query_time`

  Total number of microseconds spent by pgbouncer when actively connected to Postgres Pro, executing queries.

`total_wait_time`

  Time spent by clients waiting for a server, in microseconds.

`avg_xact_count`

  Average transactions per second in last stat period.

`avg_query_count`

  Average queries per second in last stat period.

`avg_recv`

  Average received (from clients) bytes per second.

`avg_sent`

  Average sent (to clients) bytes per second.

`avg_xact_time`

  Average transaction duration, in microseconds.

`avg_query_time`

  Average query duration, in microseconds.

`avg_wait_time`

  Time spent by clients waiting for a server, in microseconds (average per second).

#### SHOW STATS_TOTALS

Subset of `SHOW STATS` showing the total values (`total_`).

#### SHOW STATS_AVERAGES

Subset of `SHOW STATS` showing the average values (`avg_`).

#### SHOW TOTALS

Like `SHOW STATS` but aggregated across all databases.

#### SHOW SERVERS

`type`

  S, for server.

`user`

  User name pgbouncer uses to connect to server.

`database`

  Database name.

`state`

  State of the pgbouncer server connection, one of `active`, `used` or `idle`.

`addr`

  IP address of Postgres Pro server.

`port`

  Port of Postgres Pro server.

`local_addr`

  Connection start address on local machine.

`local_port`

  Connection start port on local machine.

`connect_time`

  When the connection was made.

`request_time`

  When last request was issued.

`wait`

  Current waiting time in seconds.

`wait_us`

  Microsecond part of the current waiting time.

`close_needed`

  1 if the connection will be closed as soon as possible, because a configuration file reload or DNS update changed the connection information or `RECONNECT` was issued.

`ptr`

  Address of internal object for this connection. Used as unique ID.

`link`

  Address of client connection the server is paired with.

`remote_pid`

  PID of backend server process. In case connection is made over Unix socket and OS supports getting process ID info, its OS PID. Otherwise it's extracted from cancel packet the server sent, which should be the PID in case the server is Postgres Pro, but it's a random number in case the server is another pgbouncer.

`tls`

  A string with TLS connection information, or empty if not using TLS.

#### SHOW CLIENTS

`type`

  C, for client.

`user`

  Client connected user.

`database`

  Database name.

`state`

  State of the client connection, one of `active`, `used`, `waiting` or `idle`.

`addr`

  IP address of client.

`port`

  Port client is connected to.

`local_addr`

  Connection end address on local machine.

`local_port`

  Connection end port on local machine.

`connect_time`

  Timestamp of connect time.

`request_time`

  Timestamp of latest client request.

`wait`

  Current waiting time in seconds.

`wait_us`

  Microsecond part of the current waiting time.

`close_needed`

  Not used for clients.

`ptr`

  Address of internal object for this connection. Used as unique ID.

`link`

  Address of server connection the client is paired with.

`remote_pid`

  Process ID, in case client connects over Unix socket and OS supports getting it.

`tls`

  A string with TLS connection information, or empty if not using TLS.

#### SHOW POOLS

A new pool entry is made for each couple of (database, user).

`database`

  Database name.

`user`

  User name.

`cl_active`

  Client connections that are linked to server connection and can process queries.

`cl_waiting`

  Client connections have sent queries but have not yet got a server connection.

`sv_active`

  Server connections that linked to a client.

`sv_idle`

  Server connections that are unused and immediately usable for client queries.

`sv_used`

  Server connections that have been idle for more than `server_check_delay`, so they need `server_check_query` to run on them before they can be used again.

`sv_tested`

  Server connections that are currently running either `server_reset_query` or `server_check_query`.

`sv_login`

  Server connections currently in the process of logging in.

`maxwait`

  How long the first (oldest) client in the queue has waited, in seconds. If this starts increasing, then the current pool of servers does not handle requests quickly enough. The reason may be either an overloaded server or just too small of a `pool_size` setting.

`maxwait_us`

  Microsecond part of the maximum waiting time.

`pool_mode`

  The pooling mode in use.

#### SHOW LISTS

Show following internal information, in columns (not rows):

`databases`

  Count of databases.

`users`

  Count of users.

`pools`

  Count of pools.

`free_clients`

  Count of free clients.

`used_clients`

  Count of used clients.

`login_clients`

  Count of clients in `login` state.

`free_servers`

  Count of free servers.

`used_servers`

  Count of used servers.

`dns_names`

  Count of DNS names in the cache.

`dns_zones`

  Count of DNS zones in the cache.

`dns_queries`

  Count of in-flight DNS queries.

`dns_pending`

  Not used.

#### SHOW USERS

`name`

  The user name.

`pool_mode`

  The user's override `pool_mode`, or `NULL` if the default will be used instead.

#### SHOW DATABASES

`name`

  Name of configured database entry.

`host`

  Host pgbouncer connects to.

`port`

  Port pgbouncer connects to.

`database`

  Actual database name pgbouncer connects to.

`force_user`

  When the user is part of the connection string, the connection between pgbouncer and Postgres Pro is forced to the given user, whatever the client user.

`pool_size`

  Maximum number of server connections.

`reserve_pool`

  Maximum number of additional connections for this database.

`pool_mode`

  The database's override pool_mode, or `NULL` if the default will be used instead.

`max_connections`

  Maximum number of allowed connections for this database, as set by `max_db_connections`, either globally or per database.

`current_connections`

  Current number of connections for this database.

`paused`

  1 if this database is currently paused, else 0.

`disabled`

  1 if this database is currently disabled, else 0.

#### SHOW FDS

Internal command — shows list of file descriptors (FDs) in use with internal state attached to them.

When the connected user has the user name `pgbouncer`, connects through the Unix socket and has the same UID as the running process, the actual FDs are passed over the connection. This mechanism is used to do an online restart.

### Note

This does not work on Windows systems.

This command also blocks the internal event loop, so it should not be used while pgbouncer is in use.

`fd`

  File descriptor numeric value.

`task`

  One of `pooler`, `client` or `server`.

`user`

  User of the connection using the FD.

`database`

  Database of the connection using the FD.

`addr`

  IP address of the connection using the FD, `unix` if a Unix socket is used.

`port`

  Port used by the connection using the FD.

`cancel`

  Cancel key for this connection.

`link`

  File descriptor for corresponding server/client. `NULL` if idle.

#### SHOW SOCKETS, SHOW ACTIVE_SOCKETS

Shows low-level information about sockets or only active sockets. This includes the information shown under `SHOW CLIENTS` and `SHOW SERVERS` as well as other more low-level information.

#### SHOW CONFIG

Show the current configuration settings, one per row, with the following columns:

`key`

  Configuration variable name.

`value`

  Configuration value.

`changeable`

  Either `yes` or `no`, shows if the variable can be changed while running. If `no`, the variable can be changed only at boot-time. Use `SET` to change a variable at run time.

#### SHOW MEM

Shows low-level information about the current sizes of various internal memory allocations. The information presented is subject to change.

#### SHOW DNS_HOSTS

Show host names in DNS cache.

`hostname`

  Host name.

`ttl`

  How many seconds until next lookup.

`addrs`

  Comma separated list of addresses.

#### SHOW DNS_ZONES

Show DNS zones in cache.

`zonename`

  Zone name.

`serial`

  Current serial.

`count`

  Host names belonging to this zone.

### Process Controlling Commands

#### PAUSE [`db`]

pgbouncer tries to disconnect from all servers, first waiting for all queries to complete. The command will not return before all queries are finished. To be used at the time of database restart.

If database name is given, only that database will be paused.

New client connections to a paused database will wait until `RESUME` is called.

#### DISABLE `db`

Reject all new client connections on the given database.

#### ENABLE `db`

Allow new client connections after a previous `DISABLE` command.

#### RECONNECT `db`

Close each open server connection for the given database, or all databases, after it is released (according to the pooling mode), even if its lifetime is not up yet. New server connections can be made immediately and will connect as necessary according to the pool size settings.

This command is useful when the server connection setup has changed, for example to perform a gradual switchover to a new server. It is not necessary to run this command when the connection string in `pgbouncer.ini` has been changed and reloaded (see `RELOAD`) or when DNS resolution has changed, because then the equivalent of this command will be run automatically. This command is only necessary if something downstream of pgbouncer routes the connections.

After this command is run, there could be an extended period where some server connections go to an old destination and some server connections go to a new destination. This is likely only sensible when switching read-only traffic between read-only replicas, or when switching between nodes of a multimaster replication setup. If all connections need to be switched at the same time, `PAUSE` is recommended instead. To close server connections without waiting (for example, in emergency failover rather than gradual switchover scenarios), also consider `KILL`.

#### KILL `db`

Immediately drop all client and server connections on given database.

New client connections to a killed database will wait until `RESUME` is called.

#### SUSPEND

All socket buffers are flushed and pgbouncer stops listening for data on them. The command will not return before all buffers are empty. To be used at the time of pgbouncer online reboot.

New client connections to a suspended database will wait until `RESUME` is called.

#### RESUME [`db`]

Resume work from previous `KILL`, `PAUSE`, or `SUSPEND` command.

#### SHUTDOWN

The pgbouncer process will exit.

#### RELOAD

The pgbouncer process will reload its configuration file and update changeable settings.

PgBouncer notices when a configuration file reload changes the connection parameters of a database definition. An existing server connection to the old destination will be closed when the server connection is next released (according to the pooling mode), and new server connections will immediately use the updated connection parameters.

#### WAIT_CLOSE [`db`]

Wait until all server connections, either of the specified database or of all databases, have cleared the `close_needed` state (see the section called “SHOW SERVERS”). This can be called after a `RECONNECT` or `RELOAD` to wait until the respective configuration change has been fully activated, for example in switchover scripts.

### Other Commands

#### SET `key` = `arg`

Changes a configuration setting (see also the section called “SHOW CONFIG”). For example:

    SET log_connections = 1;
    SET server_check_query = 'select 2';

(Note that this command is run on the pgbouncer admin console and sets pgbouncer settings. A `SET` command run on another database will be passed to the Postgres Pro backend like any other SQL command.)

### Signals

`SIGHUP`

  Reload config. Same as issuing the command `RELOAD` on the console.

`SIGINT`

  Safe shutdown. Same as issuing `PAUSE` and `SHUTDOWN` on the console.

`SIGTERM`

  Immediate shutdown. Same as issuing `SHUTDOWN` on the console.

`SIGUSR1`

  Same as issuing `PAUSE` on the console.

`SIGUSR2`

  Same as issuing `RESUME` on the console.

### Libevent Settings

From the libevent documentation:

> It is possible to disable support for `epoll`, `kqueue`, `devpoll`, `poll`, or `select` by setting the environment variable `EVENT_NOEPOLL`, `EVENT_NOKQUEUE`, `EVENT_NODEVPOLL`, `EVENT_NOPOLL` or `EVENT_NOSELECT`, respectively.

> By setting the environment variable `EVENT_SHOW_METHOD`, `libevent` displays the kernel notification method that it uses.

### `pgbouncer.ini` Configuration File

The configuration file is in the `.ini` format. Section names are between "[" and "]". Lines starting with ";" or "#" are taken as comments and ignored. The characters ";" and "#" are not recognized when they appear later in the line.

#### Generic Settings

`logfile`

  Specifies log file. Log file is kept open so after rotation `kill -HUP` or on console `RELOAD;` should be done. Note: On Windows systems, the service must be stopped and started.

  Default: not set

`pidfile`

  Specifies the PID file. Without a `pidfile`, daemonization is not allowed.

  Default: not set

`listen_addr`

  Specifies list of addresses, where to listen for TCP connections. You may also use `*` meaning "listen on all addresses". When not set, only Unix socket connections are allowed.

  Addresses can be specified numerically (IPv4/IPv6) or by name.

  Default: not set

`listen_port`

  Which port to listen on. Applies to both TCP and Unix sockets.

  Default: 6432

`unix_socket_dir`

  Specifies location for Unix sockets. Applies to both listening socket and server connections. If set to an empty string, Unix sockets are disabled. Required for online reboot (-R) to work. Note: Not supported on Windows systems.

  Default: /tmp

`unix_socket_mode`

  File system mode for Unix socket.

  Default: 0777

`unix_socket_group`

  Group name to use for Unix socket.

  Default: not set

`user`

  If set, specifies the Unix user to change to after startup. Works only if pgbouncer is started as root or if it's already running as given user.

  Note: Not supported on Windows systems.

  Default: not set

`auth_file`

  The name of the file to load user names and passwords from. See the section called “Authentication File Format” for details.

  Default: not set

`auth_hba_file`

  HBA configuration file to use when `auth_type` is `hba`. Supported from version 1.7 onwards.

  Default: not set

`auth_type`

  How to authenticate users.

  `pam`

    Pluggable Authentication Modules (PAM) method is used to authenticate users, `auth_file` is ignored. This method is not compatible with databases using `auth_user` option. Service name reported to PAM is `pgbouncer`. Also, PAM is still not supported in HBA configuration file.

  `hba`

    Actual authentication type is loaded from `auth_hba_file`. This allows different authentication methods different access paths. Example: connection over Unix socket uses `peer` authentication method, connection over TCP must use TLS. Supported from version 1.7 onwards.

  `cert`

    Client must connect over TLS connection with valid client certificate. Username is then taken from CommonName field from certificate.

  `md5`

    Use MD5-based password check. This is the default authentication method. `auth_file` may contain both MD5-encrypted or plain-text passwords. If `md5` is configured and a user has a SCRAM secret, then SCRAM authentication is used automatically instead.

  `scram-sha-256`

    Use password check with SCRAM-SHA-256. `auth_file` has to contain SCRAM secrets or plain-text passwords. Note that SCRAM secrets can only be used for verifying the password of a client but not for logging into a server. To be able to use SCRAM on server connections, use plain-text passwords.

  `plain`

    Clear-text password is sent over wire. Deprecated.

  `trust`

    No authentication is done. Username must still exist in `auth_file`.

  `any`

    Like the `trust` method, but the username given is ignored. Requires that all databases are configured to log in as specific user. Additionally, the console database allows any user to log in as admin.

`auth_query`

  Query to load user's password from database.

  Direct access to `pg_shadow` requires admin rights. It's preferable to use non-admin user that calls SECURITY DEFINER function instead.

  Note that the query is run inside target database, so if a function is used it needs to be installed into each database.

  Default: `SELECT usename, passwd FROM pg_shadow WHERE usename=$1`

`auth_user`

  If `auth_user` is set, any user not specified in `auth_file` will be queried through the `auth_query` query from `pg_shadow` in the database using `auth_user`. `auth_user`'s password will be taken from `auth_file`.

  Direct access to `pg_shadow` requires admin rights. It's preferable to use non-admin user that calls SECURITY DEFINER function instead.

  Default: not set

`pool_mode`

  Specifies when a server connection can be reused by other clients.

  `session`

    Server is released back to pool after client disconnects. Default.

  `transaction`

    Server is released back to pool after transaction finishes.

  `statement`

    Server is released back to pool after query finishes. Long transactions spanning multiple statements are disallowed in this mode.

`max_client_conn`

  Maximum number of client connections allowed. When increased, the file descriptor limits should also be increased. Note that actual number of file descriptors used is more than `max_client_conn`. If each user connects under its own username to server, theoretical maximum used is:

      max_client_conn + (max pool_size * total databases * total users)

  If a database user is specified in connect string (all users connect under same username), the theoretical maximum is:

      max_client_conn + (max pool_size * total databases)

  The theoretical maximum should be never reached, unless somebody deliberately crafts special load for it. Still, it means you should set the number of file descriptors to a safely high number.

  Search for `ulimit` in your favorite shell man page. Note: `ulimit` does not apply in a Windows environment.

  Default: 100

`default_pool_size`

  How many server connections to allow per user/database pair. Can be overridden in the per-database configuration.

  Default: 20

`min_pool_size`

  Add more server connections to pool if below this number. Improves behavior when usual load suddenly comes back after a period of total inactivity.

  Default: 0 (disabled)

`reserve_pool_size`

  How many additional connections to allow to a pool. The 0 value disables this parameter.

  Default: 0 (disabled)

`reserve_pool_timeout`

  If a client has not been serviced in this many seconds, pgbouncer enables use of additional connections from reserve pool. The 0 value disables this parameter.

  Default: 5.0

`max_db_connections`

  Do not allow more than this many connections per-database (regardless of pool — i.e. user). It should be noted that when you hit the limit, closing a client connection to one pool will not immediately allow a server connection to be established for another pool, because the server connection for the first pool is still open. Once the server connection closes (due to idle timeout), a new server connection will immediately be opened for the waiting pool.

  Default: unlimited

`max_user_connections`

  Do not allow more than this many connections per-user (regardless of pool — i.e. user). It should be noted that when you hit the limit, closing a client connection to one pool will not immediately allow a server connection to be established for another pool, because the server connection for the first pool is still open. Once the server connection closes (due to idle timeout), a new server connection will immediately be opened for the waiting pool.

`server_round_robin`

  By default, pgbouncer reuses server connections in LIFO (last-in, first-out) manner, so that few connections get the most load. This gives best performance if you have a single server serving a database. But if there is TCP round-robin behind a database IP, then it is better if pgbouncer also uses connections in that manner, thus achieving uniform load.

  Default: 0

`ignore_startup_parameters`

  By default, pgbouncer allows only parameters it can keep track of in startup packets — `client_encoding`, `datestyle`, `timezone` and `standard_conforming_strings`.

  All other parameters will raise an error. To allow other parameters, they can be specified here, so that pgbouncer knows that they are handled by admin and it can ignore them.

  Default: empty

`disable_pqexec`

  Disable Simple Query protocol (PQexec). Unlike Extended Query protocol, Simple Query allows multiple queries in one packet, which allows some classes of SQL-injection attacks. Disabling it can improve security. Obviously this means only clients that exclusively use Extended Query protocol will stay working.

  Default: 0

`application_name_add_host`

  Add the client host address and port to the application name setting set on connection start. This helps in identifying the source of bad queries, etc. This logic applies only on start of connection, if `application_name` is later changed with `SET`, pgbouncer does not change it again.

  Default: 0

`conffile`

  Show location of current configuration file. Changing it will make pgbouncer use another configuration file for next `RELOAD` / `SIGHUP`.

  Default: file from command line.

`service_name`

  Used on win32 service registration.

  Default: pgbouncer

`job_name`

  Alias for `service_name`.

`stats_period`

  Sets how often the averages shown in various `SHOW` commands are updated and how often aggregated statistics are written to the log (but see `log_stats`). [seconds]

  Default: 60

#### Log Settings

`syslog`

  Toggles syslog on/off. On Windows systems, eventlog is used instead.

  Default: 0

`syslog_ident`

  Under what name to send logs to syslog.

  Default: `pgbouncer` (program name)

`syslog_facility`

  Under what facility to send logs to syslog. Possibilities: `auth`, `authpriv`, `daemon`, `user`, `local0-7`.

  Default: daemon

`log_connections`

  Log successful logins.

  Default: 1

`log_disconnections`

  Log disconnections with reasons.

  Default: 1

`log_pooler_errors`

  Log error messages pooler sends to clients.

  Default: 1

`stats_period`

  Period for writing aggregated stats into log.

  Default: 60

`log_stats`

  Write aggregated statistics into the log, every `stats_period`. This can be disabled if external monitoring tools are used to grab the same data from `SHOW` commands.

  Default: 1

`verbose`

  Increase verbosity. Mirrors "-v" switch on command line. Using "-v -v" on command line is same as `verbose=2` in configuration file.

  Default: 0

#### Console Access Control

`admin_users`

  Comma-separated list of database users that are allowed to connect and run all commands on console. Ignored when `auth_type` is `any`, in which case any username is allowed in as admin.

  Default: empty

`stats_users`

  Comma-separated list of database users that are allowed to connect and run read-only queries on console. That means all SHOW commands except SHOW FDS.

  Default: empty.

#### Connection Sanity Checks, Timeouts

`server_reset_query`

  Query sent to server on connection release, before making it available to other clients. At that moment no transaction is in progress so it should not include `ABORT` or `ROLLBACK`.

  The query is supposed to clean any changes made to database session so that next client gets connection in well-defined state. Default is `DISCARD ALL` which cleans everything, but that leaves next client no pre-cached state. It can be made lighter, e.g. `DEALLOCATE ALL` to just drop prepared statements, if application does not break when some state is kept around.

  When transaction pooling is used, the `server_reset_query` is not used, as clients must not use any session-based features as each transaction ends up in different connection and thus gets different session state.

  Default: DISCARD ALL

`server_reset_query_always`

  Whether `server_reset_query` should be run in all pooling modes. When this setting is off (default), the `server_reset_query` will be run only in pools that are in sessions-pooling mode. Connections in transaction-pooling mode should not have any need for reset query.

  It is workaround for broken setups that run apps that use session features over transaction-pooled pgbouncer. It changes non-deterministic breakage to deterministic breakage — client always lose their state after each transaction.

  Default: 0

`server_check_delay`

  How long to keep released connections available for immediate re-use, without running sanity-check queries on it. If 0 then the query is always run.

  Default: 30.0

`server_check_query`

  Simple do-nothing query to check if the server connection is alive.

  If an empty string, then sanity checking is disabled.

  Default: SELECT 1;

`server_fast_close`

  Disconnect a server in session pooling mode immediately or after the end of the current transaction if it is in `close_needed` mode (set by `RECONNECT`, `RELOAD` that changes connection settings, or DNS change), rather than waiting for the session end. In statement or transaction pooling mode, this has no effect since that is the default behavior there.

  If because of this setting a server connection is closed before the end of the client session, the client connection is also closed. This ensures that the client notices that the session has been interrupted.

  This setting makes connection configuration changes take effect sooner if session pooling and long-running sessions are used. The downside is that client sessions are liable to be interrupted by a configuration change, so client applications will need logic to reconnect and reestablish session state. But note that no transactions will be lost, because running transactions are not interrupted, only idle sessions.

  Default: 0

`server_lifetime`

  The pooler will close an unused server connection that has been connected longer than this. Setting it to 0 means the connection is to be used only once, then closed. [seconds]

  Default: 3600.0

`server_idle_timeout`

  If a server connection has been idle more than this many seconds it will be dropped. If 0 then timeout is disabled. [seconds]

  Default: 600.0

`server_connect_timeout`

  If connection and login won't finish in this amount of time, the connection will be closed. [seconds]

  Default: 15.0

`server_login_retry`

  If login failed, because of failure from connect() or authentication that pooler waits this much before retrying to connect. [seconds]

  Default: 15.0

`client_login_timeout`

  If a client connects but does not manage to login in this amount of time, it will be disconnected. Mainly needed to avoid dead connections stalling SUSPEND and thus online restart. [seconds]

  Default: 60.0

`autodb_idle_timeout`

  If the automatically created (via "*") database pools have been unused this many seconds, they are freed. The negative aspect of that is that their statistics are also forgotten. [seconds]

  Default: 3600.0

`dns_max_ttl`

  How long the DNS lookups can be cached. If a DNS lookup returns several answers, pgbouncer will robin-between them in the meantime. Actual DNS TTL is ignored. [seconds]

  Default: 15.0

`dns_nxdomain_ttl`

  How long error and NXDOMAIN DNS lookups can be cached. [seconds]

  Default: 15.0

`dns_zone_check_period`

  Period to check if zone serial has changed.

  pgbouncer can collect DNS zones from host names (everything after first dot) and then periodically check if zone serial changes. If it notices changes, all host names under that zone are looked up again. If any host IP changes, it's connections are invalidated.

  Works only with UDNS and c-ares backends (`--with-udns` or `--with-cares` to configure).

  Default: 0.0 (disabled)

#### TLS Settings

`client_tls_sslmode`

  TLS mode to use for connections from clients. TLS connections are disabled by default. When enabled, `client_tls_key_file` and `client_tls_cert_file` must be also configured to set up key and cert pgbouncer uses to accept client connections.

  `disable`

    Plain TCP. If client requests TLS, it's ignored. Default.

  `allow`

    If client requests TLS, it is used. If not, plain TCP is used. If client uses client-certificate, it is not validated.

  `prefer`

    Same as `allow`.

  `require`

    Client must use TLS. If not, client connection is rejected. If client uses client-certificate, it is not validated.

  `verify-ca`

    Client must use TLS with valid client certificate.

  `verify-full`

    Same as `verify-ca`.

`client_tls_key_file`

  Private key for pgbouncer to accept client connections.

  Default: not set.

`client_tls_cert_file`

  Certificate for private key. Clients can validate it.

  Default: not set.

`client_tls_ca_file`

  Root certificate file to validate client certificates.

  Default: unset.

`client_tls_protocols`

  Which TLS protocol versions are allowed. Allowed values: `tlsv1.0`, `tlsv1.1`, `tlsv1.2`, `tlsv1.3`. Shortcuts: `all` (tlsv1.0,tlsv1.1,tlsv1.2,tlsv1.3), `secure` (tlsv1.2,tlsv1.3), `legacy` (all).

  Default: `all`

`client_tls_ciphers`

  Default: `fast`

`client_tls_ecdhcurve`

  Elliptic Curve name to use for ECDH key exchanges.

  Allowed values: `none` (DH is disabled), `auto` (256-bit ECDH), curve name.

  Default: `auto`

`client_tls_dheparams`

  DHE key exchange type.

  Allowed values: `none` (DH is disabled), `auto` (2048-bit DH), `legacy` (1024-bit DH).

  Default: `auto`

`server_tls_sslmode`

  TLS mode to use for connections to Postgres Pro servers. TLS connections are disabled by default.

  `disable`

    Plain TCP. TLS is not even requested from server. Default.

  `prefer`

    TLS connection is always requested first from Postgres Pro, when refused connection will be established over plain TCP. Server certificate is not validated.

  `require`

    Connection must go over TLS. If server rejects it, plain TCP is not attempted. Server certificate is not validated.

  `verify-ca`

    Connection must go over TLS and server certificate must be valid according to `server_tls_ca_file`. Server host name is not checked against certificate.

  `verify-full`

    Connection must go over TLS and server certificate must be valid according to `server_tls_ca_file`. Server host name must match certificate info.

`server_tls_ca_file`

  Root certificate file to validate Postgres Pro server certificates.

  Default: unset.

`server_tls_key_file`

  Private key for pgbouncer to authenticate against Postgres Pro server.

  Default: not set.

`server_tls_cert_file`

  Certificate for private key. Postgres Pro server can validate it.

  Default: not set.

`server_tls_protocols`

  Which TLS protocol versions are allowed. Allowed values: `tlsv1.0`, `tlsv1.1`, `tlsv1.2`, `tlsv1.3`. Shortcuts: `all` (tlsv1.0,tlsv1.1,tlsv1.2,tlsv1.3), `secure` (tlsv1.2,tlsv1.3), `legacy` (all).

  Default: `all`

`server_tls_ciphers`

  Default: `fast`

#### Dangerous Timeouts

Setting the following timeouts causes unexpected errors.

`query_timeout`

  Queries running longer than that are canceled. This should be used only with slightly smaller server-side `statement_timeout`, to apply only for network problems. [seconds]

  Default: 0.0 (disabled)

`query_wait_timeout`

  Maximum time queries are allowed to spend waiting for execution. If the query is not assigned to a server during that time, the client is disconnected. This is used to prevent unresponsive servers from grabbing up connections. [seconds]

  It also helps when server is down or database rejects connections for any reason. If this is disabled, clients will be queued infinitely.

  Default: 120

`client_idle_timeout`

  Client connections idling longer than this many seconds are closed. This should be larger than the client-side connection lifetime settings, and only used for network problems. [seconds]

  Default: 0.0 (disabled)

`idle_transaction_timeout`

  If client has been in "idle in transaction" state longer, it will be disconnected. [seconds]

  Default: 0.0 (disabled)

#### Low-Level Network Settings

`pkt_buf`

  Internal buffer size for packets. Affects size of TCP packets sent and general memory usage. Actual libpq packets can be larger than this, so, no need to set it large.

  Default: 4096

`max_packet_size`

  Maximum size for Postgres Pro packets that pgbouncer allows through. One packet is either one query or one result set row. Full result set can be larger.

  Default: 2147483647

`listen_backlog`

  Backlog argument for listen(2). Determines how many new unanswered connection attempts are kept in queue. When queue is full, further new connections are dropped.

  Default: 128

`sbuf_loopcnt`

  How many times to process data on one connection, before proceeding. Without this limit, one connection with a big result set can stall pgbouncer for a long time. One loop processes one `pkt_buf` amount of data. 0 means no limit.

  Default: 5

`suspend_timeout`

  How many seconds to wait for buffer flush during SUSPEND or reboot (-R). Connection is dropped if flush does not succeed.

  Default: 10

`tcp_defer_accept`

  For details on this and other TCP options, please see `man 7 tcp`.

  Default: 45 on Linux, otherwise 0

`tcp_socket_buffer`

  Default: not set

`tcp_keepalive`

  Turns on basic keepalive with OS defaults.

  On Linux, the system defaults are tcp_keepidle=7200, tcp_keepintvl=75, tcp_keepcnt=9. They are probably similar on other operating systems.

  Default: 1

`tcp_keepcnt`

  Default: not set

`tcp_keepidle`

  Default: not set

`tcp_keepintvl`

  Default: not set

#### Section [databases]

This contains key=value pairs where key will be taken as a database name and value as a libpq connect-string style list of key=value pairs. As actual libpq is not used, not all features from libpq can be used (service=, .pgpass).

Database name can contain characters `_0-9A-Za-z` without quoting. Names that contain other chars need to be quoted with standard SQL ident quoting: double quotes where "" is taken as single quote.

"*" acts as fallback database: if the exact name does not exist, its value is taken as connect string for requested database. Such automatically created database entries are cleaned up if they stay idle longer than the time specified in `autodb_idle_timeout` parameter.

`dbname`

  Destination database name.

  Default: same as client-side database name.

`host`

  Host name or IP address to connect to. Host names are resolved at connect time, the result is cached per `dns_max_ttl` parameter. When a host name's resolution changes, existing server connections are automatically closed when they are released (according to the pooling mode), and new server connections immediately use the new resolution. If DNS returns several results, they are used in round-robin manner.

  Default: not set, meaning to use a Unix socket.

`port`

  Default: 5432

`user`

  If `user=` is set, all connections to the destination database will be done with the specified user, meaning that there will be only one pool for this database.

  Otherwise pgbouncer tries to log into the destination database with client username, meaning that there will be one pool per user.

`password`

  The length for `password` is limited to 160 characters maximum.

  If no password is specified here, the password from the `auth_file` or `auth_query` will be used.

`auth_user`

  Override of the global `auth_user` setting, if specified.

`pool_size`

  Set maximum size of pools for this database. If not set, the `default_pool_size` is used.

`reserve_pool`

  Set additional connections for this database. If not set, `reserve_pool_size` is used.

`connect_query`

  Query to be executed after a connection is established, but before allowing the connection to be used by any clients. If the query raises errors, they are logged but ignored otherwise.

`pool_mode`

  Set the pool mode specific to this database. If not set, the default pool_mode is used.

`max_db_connections`

  Configure a database-wide maximum (i.e. all pools within the database will not have more than this many server connections).

`client_encoding`

  Ask specific `client_encoding` from server.

`datestyle`

  Ask specific `datestyle` from server.

`timezone`

  Ask specific `timezone` from server.

#### Section [users]

This contains key=value pairs where the key will be taken as a user name and the value as a libpq connect-string style list of key=value pairs of configuration settings specific for this user. Only a few settings are available here.

`pool_mode`

  Set the pool mode to be used for all connections from this user. If not set, the database or default pool_mode is used.

`max_user_connections`

  Configure a maximum for the user (i.e. all pools with the user will not have more than this many server connections).

#### Include Directive

The pgbouncer config file can contain include directives, which specify another configuration file to read and process. This allows for splitting the configuration file into physically separate parts. The include directives look like this:

    %include filename

If the file name is not absolute path it is taken as relative to current working directory.

#### Authentication File Format

pgbouncer needs its own user database. The users are loaded from a text file in following format:

    "username1" "password" ...
    "username2" "md5abcdef012342345" ...
    "username2" "SCRAM-SHA-256$iterations:salt$storedkey:serverkey"

There should be at least two fields, surrounded by double quotes. The first field is the username and the second is either a plain-text, a MD5-hidden password, or a SCRAM secret. pgbouncer ignores the rest of the line.

Postgres Pro MD5-hidden password format:

    "md5" + md5(password + username)

So user `admin` with password `1234` will have MD5-hidden password `md545f2603610af569b6155c45067268c6b`.

Postgres Pro SCRAM secret format:

    SCRAM-SHA-256$iterations:salt$storedkey:serverkey

The authentication file can be written by hand, but it's also useful to generate it from some other list of users and passwords. See `./etc/mkauth.py` for a sample script to generate the authentication file from the `pg_shadow` system table.

#### HBA File Format

It follows the format of Postgres Pro `pg_hba.conf` file described in Section 19.1.

- Supported record types: `local`, `host`, `hostssl`, `hostnossl`.

- Database field: Supports `all`, `sameuser`, @`file`, multiple names. Not supported: `replication`, `samerole`, `samegroup`.

- Username field: Supports `all`, @`file`, multiple names. Not supported: `+groupname`.

- Address field: Supported `IPv4`, `IPv6`. Not supported: DNS names, domain prefixes.

- Auth-method field: Only methods supported by pgbouncer's `auth_type` are supported, except `any` and `pam`, which only work globally. Username map (`map=`) parameter is not supported.

#### Example

Minimal config:

    [databases]
    template1 = host=127.0.0.1 dbname=template1 auth_user=someuser

    [pgbouncer]
    pool_mode = session
    listen_port = 6543
    listen_addr = 127.0.0.1
    auth_type = md5
    auth_file = users.txt
    logfile = pgbouncer.log
    pidfile = pgbouncer.pid
    admin_users = someuser
    stats_users = stat_collector

Database defaults:

    [databases]

    ; foodb over Unix socket
    foodb =

    ; redirect bardb to bazdb on localhost
    bardb = host=127.0.0.1 dbname=bazdb

    ; access to destination database will go with single user
    forcedb = host=127.0.0.1 port=300 user=baz password=foo client_encoding=UNICODE datestyle=ISO

Example of a secure function for `auth_query`:

    CREATE OR REPLACE FUNCTION pgbouncer.user_lookup(in i_username text, out uname text, out phash text)
    RETURNS record AS $$
    BEGIN
        SELECT usename, passwd FROM pg_catalog.pg_shadow
        WHERE usename = i_username INTO uname, phash;
        RETURN;
    END;
    $$ LANGUAGE plpgsql SECURITY DEFINER;
    REVOKE ALL ON FUNCTION pgbouncer.user_lookup(text) FROM public, pgbouncer;
    GRANT EXECUTE ON FUNCTION pgbouncer.user_lookup(text) TO pgbouncer;